% MTODO 2
% TEST 2. CLCULO DEL ESTADSTICO DE CONTRASTE.
%
% La referencia utilizada ha sido:
%
% 	J. M. Amig, S. Zambrano, M. A. F. Sanjun
%	DETECTING DETERMINISM IN TIME SERIES WITH ORDINAL PATTERNS: A
%	COMPARATIVE STUDY
%	International Journal of Bifurcation and Chaos, Vol. 20, No. 9 (2010),
%	2915-2924

function Estadistico_contraste=calcula_EC_Amigo(serie_temp,m)

serie=serie_temp; % serie temporal
T=length(serie); % nmero de elementos de la serie
k=fix((T-1)/(m-1)); % nmero de tramos

M_permutaciones=zeros(factorial(m),m);
Fabs_permutacion=zeros(factorial(m),1);

trozo_serie1=serie(1:m);
[trozo_ordenado1,permutacion1]=sort(trozo_serie1);
M_permutaciones(1,:)=permutacion1;
Npermutaciones_diferentes=1;
Fabs_permutacion(1)=1;

for cont1=m:m-1:T-m+1
    
    trozo_serie=serie(cont1:cont1+m-1);
    [trozo_ordenado,permutacion]=sort(trozo_serie);
        
    testigo=1;
    
    for cont2=1:Npermutaciones_diferentes
        
        if isequal(M_permutaciones(cont2,:),permutacion)
            
            Fabs_permutacion(cont2)=Fabs_permutacion(cont2)+1;
            testigo=0;
            break            
            
        end
        
    end
    
    if testigo
        
    Npermutaciones_diferentes=Npermutaciones_diferentes+1;    
    M_permutaciones(Npermutaciones_diferentes,:)=permutacion;
    Fabs_permutacion(Npermutaciones_diferentes)=1;
    
    end
    
end

suma_auxiliar=0; 

for cont3=1:Npermutaciones_diferentes
      
    suma_auxiliar=suma_auxiliar+Fabs_permutacion(cont3)^2;
          
end

Estadistico_contraste=(factorial(m)/k)*suma_auxiliar-k; % estadstico de contraste
