% MTODO 1
% TEST 1. CLCULO DEL ESTADSTICO DE CONTRASTE (G).
%
% La referencia utilizada ha sido:
%
% 	M. Matilla-Garca, M. Ruz
%	A NON-PARAMETRIC INDEPENDENCE TEST USING PERMUTATION ENTROPY
%	Journal of Econometrics 144 (2008), 139-155

function G=calcula_EC_Matilla(serie_temp,m)

serie=serie_temp; % serie temporal
T=length(serie); % nmero de elementos de la serie

M_permutaciones=zeros(factorial(m),m);
Fabs_permutacion=zeros(factorial(m),1);

trozo_serie1=serie(1:m);
[trozo_ordenado1,permutacion1]=sort(trozo_serie1);
M_permutaciones(1,:)=permutacion1;
Npermutaciones_diferentes=1;
Fabs_permutacion(1)=1;

for cont1=2:T-m+1
    
    trozo_serie=serie(cont1:cont1+m-1);
    [trozo_ordenado,permutacion]=sort(trozo_serie);
        
    testigo=1;
    
    for cont2=1:Npermutaciones_diferentes
        
        if isequal(M_permutaciones(cont2,:),permutacion)
            
            Fabs_permutacion(cont2)=Fabs_permutacion(cont2)+1;
            testigo=0;
            break            
            
        end
        
    end
    
    if testigo
        
        Npermutaciones_diferentes=Npermutaciones_diferentes+1;
        M_permutaciones(Npermutaciones_diferentes,:)=permutacion;
        Fabs_permutacion(Npermutaciones_diferentes)=1;
    
    end
    
end

Frel_permutacion=Fabs_permutacion/(T-m+1);

H=0; % entropa de permutacin 

for cont3=1:Npermutaciones_diferentes
      
    incremento_H=-Frel_permutacion(cont3)*log(Frel_permutacion(cont3));
    H=H+incremento_H;
      
end

G=2*(T-m+1)*(log(factorial(m))-H); % estadstico de contraste
