% ENSAYOS PARA LA COMPARACIN DE TEST PARA EL ESTUDIO DE LA DEPENDENCIA.
%
% Los test estudiados son:
% 
%      - M. Matilla-Garca, M. Ruz.
%      - J. M. Amig, S. Zambrano, M. A. F. Sanjun.
%      - J. S. Cnovas, A. Guillamn (test 1, 2 y 3).
%      - BDS.

Nrepeticiones=1;

Niveles_confianza=[90,95,99];
epsilon_sigma=[0.5,1,1.5,2];

matriz_Matilla=zeros(3,2);
matriz_Amigo=zeros(3,2);
matriz_CyG1=zeros(3,2);
matriz_CyG2=zeros(3,1);
matriz_CyG3=zeros(3,1);
matriz_BDS=zeros(12,7);

T=18000;

switch T
    
    case 360
        
        m_Matilla=[4,5]; m_Amigo=[4,5]; m_CyG1=[4,5]; m_CyG2y3=3; m_max_BDS=8;
        vc_CyG1=[23,51;22,50;21,48];
    
    case 720
        
        m_Matilla=[4,5]; m_Amigo=[4,5]; m_CyG1=[5,6]; m_CyG2y3=3; m_max_BDS=8;
        vc_CyG1=[80,107;78,106;76,104];
        
    case 1080
        
        m_Matilla=[4,5]; m_Amigo=[4,5]; m_CyG1=[5,6]; m_CyG2y3=3; m_max_BDS=8;
        vc_CyG1=[96,154;95,153;93,150];
        
    case 1440
        
        m_Matilla=[4,5]; m_Amigo=[4,5]; m_CyG1=[5,6]; m_CyG2y3=3; m_max_BDS=8;
        vc_CyG1=[106,198;105,196;103,193];
        
    case 1920
        
        m_Matilla=[4,5]; m_Amigo=[4,5]; m_CyG1=[5,6]; m_CyG2y3=4; m_max_BDS=8;
        vc_CyG1=[113,251;112,249;110,245];
        
    case 3840
        
        m_Matilla=[5,6]; m_Amigo=[4,5]; m_CyG1=[5,6]; m_CyG2y3=4; m_max_BDS=8;
        vc_CyG1=[119,414;119,411;118,405];
        
    case 5760
        
        m_Matilla=[5,6]; m_Amigo=[4,5]; m_CyG1=[6,7]; m_CyG2y3=4; m_max_BDS=8;
        vc_CyG1=[519,749;516,747;510,741];
        
    case 7680
        
        m_Matilla=[5,6]; m_Amigo=[4,5]; m_CyG1=[6,7]; m_CyG2y3=4; m_max_BDS=8;
        vc_CyG1=[588,974;585,971;580,964];
        
    case 9600
        
        m_Matilla=[5,6]; m_Amigo=[4,5]; m_CyG1=[6,7]; m_CyG2y3=4; m_max_BDS=8;
        vc_CyG1=[633,1186;630,1182;625,1175];
        
    case 12000
        
        m_Matilla=[5,6]; m_Amigo=[4,5]; m_CyG1=[6,7]; m_CyG2y3=5; m_max_BDS=8;
        vc_CyG1=[668,1437;666,1432;661,1423];
        
    case 15000
        
        m_Matilla=[5,6]; m_Amigo=[4,5]; m_CyG1=[6,7]; m_CyG2y3=5; m_max_BDS=8;
        vc_CyG1=[692,1726;690,1720;687,1710];
        
    case 18000
        
        m_Matilla=[5,6]; m_Amigo=[5,6]; m_CyG1=[6,7]; m_CyG2y3=5; m_max_BDS=8;
        vc_CyG1=[705,1992;703,1986;701,1975];
        
end

for a=1:Nrepeticiones
    
    %serie=zeros(1,T);
    %serie(1)=0.45;
    %
    %for i=2:T
    %    
    %    serie(i)=4*serie(i-1)*(1-serie(i-1));
    %    
    %end
    
    serie=zeros(1,T);
    serie(1)=0.45;
    serie(2)=0.3;
    
    for i=3:T
        
        serie(i)=4*serie(i-1)*(1-serie(i-1));
        
    end
    
    %serie=2*rand(1,T)-1;

    %serie=randn(1,T);

    %serie=zeros(1,T);
    %serie(1)=0.45;
    %
    %for i=2:T
    %    
    %    serie(i)=0.3*serie(i-1)+(2*rand-1);
    %    
    %end

    %serie=zeros(1,T);
    %serie(1)=0.45;
    %
    %for i=2:T
    %    
    %    serie(i)=0.3*serie(i-1)+randn;
    %    
    %end

    %serie=zeros(1,T);
    %serie(1)=0.45;
    %
    %for i=2:T
    %    
    %    serie(i)=serie(i-1)+(2*rand-1);
    %    
    %end

    %serie=zeros(1,T);
    %serie(1)=0.45;
    %
    %for i=2:T
    %    
    %    serie(i)=serie(i-1)+randn;
    %    
    %end

    for b=1:2
        
        m=m_Matilla(b);
        G=calcula_EC_Matilla(serie,m);
        grados_libertad=factorial(m)-1;
        
        for c=1:3
            
            nc=Niveles_confianza(c);
            chi_cuadrado=chi2inv(nc/100,grados_libertad);
            
            if G>chi_cuadrado
                
                matriz_Matilla(c,b)=matriz_Matilla(c,b)+100/Nrepeticiones;
                
            end
            
        end
        
    end
    
    for b=1:2
        
        m=m_Amigo(b);
        EC=calcula_EC_Amigo(serie,m);
        grados_libertad=factorial(m)-1;
        
        for c=1:3
            
            nc=Niveles_confianza(c);
            chi_cuadrado=chi2inv(nc/100,grados_libertad);
            
            if EC>chi_cuadrado
                
                matriz_Amigo(c,b)=matriz_Amigo(c,b)+100/Nrepeticiones;
                
            end
            
        end
        
    end
    
    for b=1:2
        
        m=m_CyG1(b);
        EC=calcula_EC_CyG1(serie,m);
        
        for c=1:3
            
            if EC<vc_CyG1(c,b)
                
                matriz_CyG1(c,b)=matriz_CyG1(c,b)+100/Nrepeticiones;
                
            end
            
        end
        
    end
           
    m=m_CyG2y3;
    auxiliar=calcula_EC_CyG2y3(serie,m);
    EC_t2=auxiliar(1);
    grados_libertad=factorial(m)-1;
    pV_t3=auxiliar(2);
        
    for c=1:3
        
        nc=Niveles_confianza(c);
        chi_cuadrado=chi2inv(nc/100,grados_libertad);
        ns=1-nc/100;
    
        if EC_t2>chi_cuadrado
            
            matriz_CyG2(c)=matriz_CyG2(c)+100/Nrepeticiones;
            
        end
        
        if pV_t3<ns
            
            matriz_CyG3(c)=matriz_CyG3(c)+100/Nrepeticiones;
            
        end
        
    end
    
    for b=1:4
        
        eps_sig=epsilon_sigma(b);
        auxiliar=bds(serie,8,eps_sig,0,500);
        
        for c=1:3
            
            nc=Niveles_confianza(c);
            normal=norminv((1+nc/100)/2,0,1);
            
            for d=1:7
                
                if abs(auxiliar(d))>normal
                    
                    matriz_BDS(b+4*(c-1),d)=matriz_BDS(b+4*(c-1),d)+100/Nrepeticiones;
                    
                end
                
            end
            
        end
        
    end
    
end
